/**********************************************************\ 
Original Author: Richard Bateman and Georg Fritzsche 

Created:    December 3, 2009
License:    Dual license model; choose one of two:
            New BSD License
            http://www.opensource.org/licenses/bsd-license.php
            - or -
            GNU Lesser General Public License, version 2.1
            http://www.gnu.org/licenses/lgpl-2.1.html

Copyright 2009 PacketPass Inc, Georg Fritzsche,
               Firebreath development team
\**********************************************************/

#include <string>
#include <sstream>
#include "JSAPIAuto.h"
#include "BrowserHost.h"
#include <boost/weak_ptr.hpp>
#include <boost/optional.hpp>
#include "FBPointers.h"

FB_FORWARD_PTR(AdvantageDataSecurityPlugin);

class AdvantageDataSecurityPluginAPI : public FB::JSAPIAuto
{
public:
    AdvantageDataSecurityPluginAPI(const AdvantageDataSecurityPluginPtr& plugin, const FB::BrowserHostPtr& host);
    virtual ~AdvantageDataSecurityPluginAPI();

    FB_JSAPI_EVENT(fired, 1, (const std::string));

    AdvantageDataSecurityPluginPtr getPlugin();
    
    std::string get_pluginPath();

	std::string get_pluginId();

	std::string get_MACAddress();
	
	std::string get_Version();
	
	std::string get_InternalIP();

	std::string get_UUID();

	std::string get_Serial();

	std::string get_MBSerial();

	std::string get_MBManufacturer();

	std::string get_OS();

	std::string get_OSUsername();

	std::string adiEncrypt(std::string);

private:
    FB::BrowserHostPtr m_host;
    AdvantageDataSecurityPluginWeakPtr m_pluginWeak;
};

